; This is the source code for the custom utility ROM.
; (C)2006 FMan/Tropyx. All rights reserved.

	!to "ROMBuild.cde",plain
	*=$8000

	NDX = $c6
	KEYD = $277

	BANK0 = 0
	BANK1 = 8
	BANK2 = $10
	BANK3 = $18
	BANK4 = $80
	BANK5 = $88
	BANK6 = $90
	BANK7 = $98

	tempc = $69
	srclo = $6a
	srchi = $6b
	maxlo = $6c
	maxhi = $6d
	dstlo = $6e
	dsthi = $6f

	banks = $81b8		; starting bank for each program
	table = $81c0		; start and end addresses
	screen = $8200		; menu

	bank = $c2ac		; bank byte table in RAM

	!word start,$fce2
	!byte $c3,$c2,$cd,$38,$30

Sysstr	!pet "sys49959",13

start	!binary "reset.cde",,2	; bring in prewritten reset code

	cli
	lda #14			; color settings for user
	sta $d020
	lda #6
	sta $d021
	lda #14
	sta $286
	jsr $e544
	lda #21			; charset
	sta $d018
	ldx #0
maina	lda screen,x		; print the screen
	sta $500,x
	lda screen+256,x
	sta $600,x
	lda Runstr-$fc,x		; copies the RAM-based code there
	sta $c24c,x
	inx
	bne maina
mainloop	jsr $ffe4
	cmp #32
	bne mainla		; space is for normal reset
	jmp $c31f
mainla	sec			; key 1-8, selects program
	sbc #49
	bcc mainloop
	cmp #8
	bcs mainloop
	tay
	lda #14			; departure color settings
	sta $d020
	lda #6
	sta $d021
	lda #14
	sta $286
	lda #21			; set default charset
	sta $d018
	ldx #9			; starts the BASIC program run code by
	stx NDX			; inserting a SYS cmd into the kbd buffer
fooc	lda Sysstr-1,x
	sta KEYD-1,x
	dex
	bne fooc
	jmp $c2b4

	!byte BANK0,BANK1,BANK2,BANK3,BANK4,BANK5,BANK6,BANK7

; this is a slightly changed ROM load routine - instead of a table index,
; the argument is the number of the program to load (0-7) and also the
; number of the starting bank is now stored in a separate table

	lda banks,y		; retrieve starting bank number
	tax
	lda bank,x
	pha
	stx tempc		; bank index
	tya
	asl			; multiply number of program by four
	asl			; to arrive at the table index
	tax
	inx
	inx
	inx
	ldy #3
copyloop	lda table,x		; retrieve the start and end addresses
	sta srclo,y
	dex
	dey
	bpl copyloop
	pla
	sta $de00		; current bank byte
	lda #8
	sta dsthi
	ldy #1
	sty dstlo
	dey
readloop	lda (srclo),y
	sta (dstlo),y
	lda dsthi
	cmp maxhi
	bne fooa
	lda dstlo
	cmp maxlo
	beq done
fooa	inc srclo		; increment source address
	bne foob
	inc srchi
	lda srchi
	cmp #$a0
	bne foob
	lda #$80			; continue loading from next bank
	sta srchi
	ldx tempc
	inx
	lda bank,x
	sta $de00
	stx tempc
foob	inc dstlo		; increment destination address
	bne readloop
	inc dsthi
	bne readloop		; unconditional
done	lda maxlo
	sta $ae
	lda maxhi
	sta $af
	lda $801
	sta $c34f
	lda #2			; turn RR off and start BASIC
	sta $de00
	jmp $e394
	lda $ae			; set end of BASIC program
	sta $2d
	lda $af
	sta $2e
	lda $c34f		; restore BASIC program
	sta $801
	lda #8
	sta $802
	ldx #4			; runs a BASIC program by inserting
	stx NDX			; "RUN" + <RETURN> into the kbd buffer
fooh	lda $c347,x
	sta KEYD-1,x
	dex
	bne fooh
	rts

Runstr	!pet "run",13
