/* ROMBuild.c - source code for FMGPUCRBRR v1.20!
   2006 by Sami Klemola. All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned long ULONG;
typedef unsigned short UWORD;
typedef unsigned char UBYTE;

#define TRUE    1
#define FALSE   0

void scr(char*),uca(char*),cleanup(void),error(char*);

FILE *f;

UWORD addressen[8],enden[8],starten[8],lengthen[8];

UBYTE *image,banken[8];

char fn[]="ROMBuild.cde",s_read[]="cannot read %s",buf[256],
    s_space[]="PRESS SPACE FOR NORMAL RESET",descriptions[8][40],
    s_paper[]="\nEnter color code for background: ",
    s_border[]="\nBorder: ",s_ink[]="\nText: ";

int main(int argc,char *argv[]) {
ULONG i,o,p,q,numfiles,address;
    if(argc<3) {
        printf("Syntax: ROMBuild <ROMFile> <File1> [<File2>] [...]\n");
        return 0;
    }
    if(!(image=(UBYTE *)malloc(123456))) error("out of memory");
    memset(image,0,65536);
    if(!(f=fopen(fn,"rb"))) {
        sprintf(buf,s_read,fn);
        error(buf);
    }
    fread(image,1,440,f);
    numfiles=argc-2;
    printf("ROMBuild v1.20! Scanning %d file%s\n",
        numfiles,numfiles==1?".":"s.");
    address=1024;
    for(i=0;i<numfiles;i++) {
        printf("\nFile %d: %s. ",i+1,argv[i+2]);
        fclose(f);
        if(!(f=fopen(argv[i+2],"rb"))) {
            sprintf(buf,s_read,argv[i+2]);
            error(buf);
        }
        strcpy(descriptions[i],argv[i+2]);
        starten[i]=q=address;
        p=0;
        while(q>8192) { q-=8192; p++; }
        addressen[i]=32768+q;
        banken[i]=p;
        o=(ULONG)fgetc(f);
        if((((ULONG)fgetc(f)<<8)+o)!=2049)
            error("start address is not $801");
        if((lengthen[i]=fread(image+address,1,51234,f))>47658)
            error("file is too long");
        if((address+=lengthen[i])>65535)
            error("total size is over 64K");
        enden[i]=2049+lengthen[i];
        printf("Length: %d bytes ($%04X).",lengthen[i],lengthen[i]);
    }
    printf("\n\nTotal: $%04X or %d bytes.",address,address);
    while(TRUE) {
        printf("\n\nPlease enter a description for each program:\n\n");
        for(i=0;i<numfiles;i++) {
            printf("%-36.34s",descriptions[i]);
            gets(buf);
            if(*buf) strncpy(descriptions[i],buf,36);
        }
        printf("\nThank you. Let's review what you have here...\n\nPRG  Addr   File                  Description\n\n");
        for(i=0;i<numfiles;i++) {
            printf(" %d   $%04X  %-22.20s%s\n",i+1,starten[i],
                argv[i+2],descriptions[i]);
        }
        printf("\nDo you want to Build the ROM now, Redo the\ndescriptions or Cancel the whole thing (yes/no)? ");
        gets(buf);
        if((*buf=='b')||(*buf=='B')) break;
        if((*buf=='c')||(*buf=='C')) {
            printf("\nAs you wish. Building this ROM is hereby abandoned!\n");
            cleanup();
            exit(0);
        }
        if((*buf!='r')&&(*buf!='R')) printf("\nThat's not a valid response! As a punishment,\nyou must go through the descriptions again.");
    }
    fclose(f);
    if(f=fopen(argv[1],"rb")) {
        printf("\nWarning! The destination file exists. Overwrite? ");
        gets(buf);
        if((*buf!='y')&&(*buf!='Y')) {
            printf("\nLet's not. Cancelled!\n");
            cleanup();
            exit(0);
        }
        fclose(f);
    }
    if(!(f=fopen(argv[1],"wb"))) {
        sprintf(buf,"cannot create %s",argv[1]);
        error(buf);
    }
    while(TRUE) {
        printf("\nEnter a title for the boot menu: ");
        gets(buf);
        memset(image+512,32,512);
        scr(buf);
        strncpy((char *)image+538,buf,36);
        printf("\nKeep this title (or change)? ");
        gets(buf);
        if((*buf=='y')||(*buf=='Y')||(*buf=='k')||(*buf=='K')) break;
    }
    strcpy((char *)image+0x3d2,s_space);
    printf("\nAre you using upper/lower case display\ninstead of the regular uppercase/graphics one? ");
    gets(buf);
    if((*buf=='y')||(*buf=='Y')||(*buf=='u')||(*buf=='U'))
        image[0x57]=23; else uca((char *)image+0x3d2);
    printf("\nWould you like to customize the colors in the boot menu? ");
    gets(buf);
    if((*buf=='y')||(*buf=='Y')) {
        while(TRUE) {
            printf(s_paper);
            gets(buf);
            image[0x4a]=image[0x8c]=atoi(buf)&15;
            printf(s_border);
            gets(buf);
            image[0x45]=image[0x87]=atoi(buf)&15;
            printf(s_ink);
            gets(buf);
            image[0x4f]=image[0x91]=atoi(buf)&15;
            printf("\nKeep these colors (or change)? ");
            gets(buf);
            if((*buf=='y')||(*buf=='Y')||(*buf=='k')||(*buf=='K')) break;
        }
        printf("\nLeave these colors set when exiting bootmenu? ");
        gets(buf);
        if((*buf!='y')&&(*buf!='Y')&&(*buf!='l')&&(*buf!='L')) {
            printf("\nWould you like to set custom colors (or restore normal ones)? ");
            gets(buf);
            if((*buf=='y')||(*buf=='Y')) while(TRUE) {
                printf("\nSetting custom colors for loading programs.\n%s",
                    s_paper);
                gets(buf);
                image[0x8c]=atoi(buf)&15;
                printf(s_border);
                gets(buf);
                image[0x87]=atoi(buf)&15;
                printf(s_ink);
                gets(buf);
                image[0x91]=atoi(buf)&15;
                printf("\nKeep these colors (or change)? ");
                gets(buf);
                if((*buf=='y')||(*buf=='Y')||(*buf=='k')||(*buf=='K')) break;
            } else {
                image[0x87]=14;
                image[0x8c]=6;
                image[0x91]=14;
            }
        }
    }
    image[130]=numfiles;
    for(i=0;i<numfiles;i++) {
/*        printf("\nPRG %d: Bank %d, start $%04X, end $%04X",i+1,
            banken[i],addressen[i],enden[i]);*/
        image[0x1b8+i]=banken[i];
        o=i<<2;
        image[0x1c0+o]=addressen[i]&255;
        image[0x1c1+o]=addressen[i]>>8;
        image[0x1c2+o]=enden[i]&255;
        image[0x1c3+o]=enden[i]>>8;
        image[0x26a+40*i]=49+i;
        scr(descriptions[i]);
        strcpy((char *)image+0x26c+40*i,descriptions[i]);
    }
/*    printf("\n"); used with the debug output */
    for(i=512;i<1024;i++) if(!image[i]) image[i]=32;
    i=65536;
    if(address<32768) {
        printf("\nThe resulting ROM is less than 32 kilobytes in size.\nDo you want to make it a 32K image? ");
        gets(buf);
        if((*buf=='y')||(*buf=='Y')) {
            i>>=1;
            printf("\nAll right. 32K it is.\n");
        }
    }
    if(fwrite(image,1,i,f)<i) error("could not write image!!!");
    cleanup();
    printf("\nProduced %s for you. Enjoy!\n",argv[1]);
}

void scr(char *s) {
char c;
    while((c=*s)) {
        if(c>='a'&&c<='z') c-=96;
        *s++=c;
    }
}

void uca(char *s) {
char c;
    while((c=*s)) {
        if(c>='A'&&c<='Z') c-=64;
        *s++=c;
    }
}

void cleanup(void) {
ULONG i;
    if(f) fclose(f);
    if(image) free(image);
}

void error(char *e) {
    printf("Fatal Error: %s\n\n",e);
    cleanup();
    exit(20);
}

